from app import db
from app.decorators import background
from app.models import Corpus, CorpusFile


@background
def build_corpus(corpus_id, *args, **kwargs):
    app = kwargs['app']
    with app.app_context():
        corpus = Corpus.query.get(corpus_id)
        if corpus is None:
            raise Exception(f'Corpus {corpus_id} not found')
        corpus.build()
        db.session.commit()


@background
def delete_corpus(corpus_id, *args, **kwargs):
    with kwargs['app'].app_context():
        corpus = Corpus.query.get(corpus_id)
        if corpus is None:
            raise Exception(f'Corpus {corpus_id} not found')
        corpus.delete()
        db.session.commit()


@background
def delete_corpus_file(corpus_file_id, *args, **kwargs):
    with kwargs['app'].app_context():
        corpus_file = CorpusFile.query.get(corpus_file_id)
        if corpus_file is None:
            raise Exception(f'Corpus file {corpus_file_id} not found')
        corpus_file.delete()
        db.session.commit()
